namespace TwitchChatTTS.Seven.Socket.Data
{
    public class ChangeMapMessage
    {
        public required object Id { get; set; }
        public byte Kind { get; set; }
        public bool? Contextual { get; set; }
        public required object Actor { get; set; }
        public IEnumerable<ChangeField>? Added { get; set; }
        public IEnumerable<ChangeField>? Updated { get; set; }
        public IEnumerable<ChangeField>? Removed { get; set; }
        public IEnumerable<ChangeField>? Pushed { get; set; }
        public IEnumerable<ChangeField>? Pulled { get; set; }
    }

    public class ChangeField {
        public required string Key { get; set; }
        public int? Index { get; set; }
        public bool Nested { get; set; }
        public required object OldValue { get; set; }
        public required object Value { get; set; }
    }

    public class EmoteField {
        public required string Id { get; set; }
        public required string Name { get; set; }
        public required string ActorId { get; set; }
        public int Flags { get; set; }
    }
}